open Datatypes

type __ = Obj.t

type 'a coq_sig = 'a
  (* singleton inductive, whose constructor was exist *)

val sig_rect : ('a1 -> __ -> 'a2) -> 'a1 coq_sig -> 'a2

val sig_rec : ('a1 -> __ -> 'a2) -> 'a1 coq_sig -> 'a2

type 'a sig2 = 'a
  (* singleton inductive, whose constructor was exist2 *)

val sig2_rect : ('a1 -> __ -> __ -> 'a2) -> 'a1 sig2 -> 'a2

val sig2_rec : ('a1 -> __ -> __ -> 'a2) -> 'a1 sig2 -> 'a2

type ('a, 'p) sigS =
  | Coq_existS of 'a * 'p

val sigS_rect : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) sigS -> 'a3

val sigS_rec : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) sigS -> 'a3

type ('a, 'p, 'q) sigS2 =
  | Coq_existS2 of 'a * 'p * 'q

val sigS2_rect : ('a1 -> 'a2 -> 'a3 -> 'a4) -> ('a1, 'a2, 'a3) sigS2 -> 'a4

val sigS2_rec : ('a1 -> 'a2 -> 'a3 -> 'a4) -> ('a1, 'a2, 'a3) sigS2 -> 'a4

val proj1_sig : 'a1 coq_sig -> 'a1

val projS1 : ('a1, 'a2) sigS -> 'a1

val projS2 : ('a1, 'a2) sigS -> 'a2

val sumbool_rect : (__ -> 'a1) -> (__ -> 'a1) -> bool -> 'a1

val sumbool_rec : (__ -> 'a1) -> (__ -> 'a1) -> bool -> 'a1

val sumor_rect : ('a1 -> 'a2) -> (__ -> 'a2) -> 'a1 option -> 'a2

val sumor_rec : ('a1 -> 'a2) -> (__ -> 'a2) -> 'a1 option -> 'a2

val coq_Choice : ('a1 -> 'a2 coq_sig) -> ('a1 -> 'a2) coq_sig

val coq_Choice2 : ('a1 -> ('a2, 'a3) sigS) -> ('a1 -> 'a2, 'a1 -> 'a3) sigS

val bool_choice : ('a1 -> bool) -> ('a1 -> bool) coq_sig

type 'a coq_Exc = 'a option

val value : 'a1 -> 'a1 option

val error : __ -> 'a1 option

val except : __ -> 'a1

val absurd_set : __ -> 'a1

type ('a, 'p) sigT =
  | Coq_existT of 'a * 'p

val sigT_rect : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) sigT -> 'a3

val sigT_rec : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) sigT -> 'a3

val projT1 : ('a1, 'a2) sigT -> 'a1

val projT2 : ('a1, 'a2) sigT -> 'a2

